package com.ynet.life.util.formula.function;

import com.ynet.util.formula.CFormula;
import com.ynet.util.formula.FormulaException;
import com.ynet.util.formula.FormulaValue;
import com.ynet.util.formula.function.Function;
import java.math.BigInteger;
import java.util.List;
import java.util.regex.Pattern;

/* loaded from: com_ynet_life_util_formula_function.jar:com/ynet/life/util/formula/function/StringToNumber.class */
public class StringToNumber extends Function {
    public FormulaValue getValue(List argList) throws FormulaException {
        if (argList.size() != 1) {
            throw new FormulaException("Invalid Parameter Num of function StringToNumber(string)! Need one Parameter, Input " + argList.size());
        }
        FormulaValue stValue = ((CFormula) argList.get(0)).getValue();
        if (stValue.nDataType != 2) {
            throw new FormulaException("Invalid Parameter of function StringToNumber(string)!");
        }
        FormulaValue stResult = new FormulaValue();
        String dataValue = stValue.sStringValue();
        if (isInteger(dataValue)) {
            BigInteger intValue = new BigInteger(dataValue);
            stResult.setValue(intValue);
        } else if (isFloat(dataValue)) {
            Double doubleValue = Double.valueOf(Double.parseDouble(dataValue));
            stResult.setValue(doubleValue);
        } else {
            throw new FormulaException("Invalid Parameter of function StringToNumber(string)!, parameter value=".concat(String.valueOf(dataValue)));
        }
        return stResult;
    }

    private boolean isInteger(String str) {
        if (str == null) {
            return false;
        }
        return Pattern.compile("^[-\\+]?[0-9]+$").matcher(str).matches();
    }

    private boolean isFloat(String str) {
        if (str == null) {
            return false;
        }
        return Pattern.compile("^[-\\+]?[.\\d]*$").matcher(str).matches();
    }
}
